#!/bin/sh
# FB-main.sh
# Version 0.1.1
# ----------------------------------------------------------------------

script="FB-main"
Debugmsg=$Debugmsg"Script-Version          : $0 v0.1.1 \n"
Debugmsg=$Debugmsg"verwendbar mit          : FB.common v0.1.2 / FB.cfg v0.1.1 \n"
Debugmsg=$Debugmsg" \n"

# TR-064 aktivieren, Benützer mit User und Passwort anlegen


Debug="1"										# mit "0" deaktivieren, wenn nicht mehr benötigt
ADDONDIR="/usr/local/addons/cuxd"

#COMMON="FB.common"
COMMON="$ADDONDIR/user/FB.common"
source $COMMON




# Alle Debugnachrichten Nachrichten

ID=$(date "+%M%S"$RANDOM)
TEMPFile="$temp/FritzBox_$IP-temp_$ID.txt"
CURLFile="$temp/FritzBox_$IP-curlfile.html"
network_user_devices="$temp/FritzBox_$IP-network_user_devices.txt"




get_DECT_state(){ 		# 0 / 1
Debugmsg=$Debugmsg"URL: $FritzBoxURL/dect/dect_settings.lua?sid=$SID \n"
stateDECT=$($WEBCLIENT "$FritzBoxURL/dect/dect_settings.lua?sid=$SID" | grep '"dect:settings/enabled"' | tr -cd [:digit:])
}

get_UMTS_state(){		# 0 / 1
Debugmsg=$Debugmsg"URL: $FritzBoxURL/internet/umts_settings.lua?sid=$SID \n"
stateUMTS=$($WEBCLIENT "$FritzBoxURL/internet/umts_settings.lua?sid=$SID" | grep '"umts:settings/enabled"' | tr -cd [:digit:])
}

get_CallThrough_state(){		# 0 / 1
Debugmsg=$Debugmsg"URL: $FritzBoxURL/fon_num/callthrough.lua?sid=$SID \n"
stateCallThrough=$($WEBCLIENT "$FritzBoxURL/fon_num/callthrough.lua?sid=$SID" | grep '"telcfg:settings/CallThrough/Active"' | tr -cd [:digit:])
}




get_network_user_devices(){
if [ -f $network_user_devices ]; then
	find $temp/ -name "FritzBox_$IP-network_user_devices.txt" -mmin +3 -print0 | xargs -0 rm -f
	Debugmsg=$Debugmsg"$IP -> network_user_devices: Daten prüfen \n"	
fi
if [ -f $network_user_devices ]; then
	Debugmsg=$Debugmsg"$IP -> network_user_devices: Daten vorhanden \n"
else
	LOGIN
	#echo -n "$($WEBCLIENT "$FritzBoxURL/net/network_user_devices.lua?sid=$SID" | sed -n "/<pre>/,/<\/pre>/p" )" > $network_user_devices
	echo -n "$($WEBCLIENT "$FritzBoxURL/net/network_user_devices.lua?sid=$SID" | sed -n "/<pre>/,/<\/pre>/p" | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' )" > $network_user_devices	
#	echo -n "$($WEBCLIENT "$FritzBoxURL/net/network_user_devices.lua?sid=$SID" | grep '"_node"] = "landevice' -A27 -B2 | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' )" > $network_user_devices
	Debugmsg=$Debugmsg"$IP -> network_user_devices: Daten holen ($FritzBoxURL/net/network_user_devices.lua?sid=$SID) \n"
fi
}


get_FritzOS(){
if [ -f $FritzOS_tmp ]; then
	find $temp/ -name "FritzBox_$IP-FritzOS.txt" -mtime +7 -print0 | xargs -0 rm -f
	Debugmsg=$Debugmsg"$IP -> FritzOS: Daten prüfen \n"	
fi
if [ -f $FritzOS_tmp ]; then
	Debugmsg=$Debugmsg"$IP -> FritzOS: Daten vorhanden \n"
else
	LOGIN
	echo -n "$($WEBCLIENT "$FritzBoxURL/system/update.lua?sid=$SID" | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' | grep "logic:status/nspver" | sed -e 's/\ //g' | sed "s|.*=\(.*\),.*|\\1|")" > $FritzOS_tmp
	Debugmsg=$Debugmsg"$IP -> FritzOS: Daten holen ($FritzBoxURL/system/update.lua?sid=$SID) \n"
fi
}

# Debug Setzte alle Parameter für Logfile





Debugmsg=$Debugmsg"INFO:  Befehl $1 $2 $3 $4 \n"
case $1 in
	"test")  		Debugmsg=$Debugmsg"test: erfolgreich\n"	

					;;
	"WLAN")  		# sh FB-main.sh WLAN state CUX2801234:1
					location="http://$IP:49000/upnp/control/wlanconfig1"
					uri="urn:dslforum-org:service:WLANConfiguration:1"
					SoapParam='NewEnable'
					if [ $2 = "0" ] || [ $2 = "1" ]; then
						Action='SetEnable'			
					    set_TR064 $2
					elif [ $2 = "state" ]; then 
						Action='GetInfo'
						get_TR064
					    set_CUxD_state $TR064_temp $3 $1
					elif [ $2 = "state1" ]; then 
						Action='GetInfo'
						get_TR064
					    set_CCU_SysVar $TR064_temp $3 $1
					fi
					;;
	"WLAN5G")		location="http://$IP:49000/upnp/control/wlanconfig2"
					uri="urn:dslforum-org:service:WLANConfiguration:2"
					SoapParam='NewEnable'
					if [ $2 = "0" ] || [ $2 = "1" ]; then
						Action='SetEnable'			
					    set_TR064 $2
					elif [ $2 = "state" ]; then 
						Action='GetInfo'
						get_TR064
					    set_CUxD_state $TR064_temp $3 $1
					elif [ $2 = "state1" ]; then 
						Action='GetInfo'
						get_TR064
					    set_CCU_SysVar $TR064_temp $3 $1	
					fi
					;;
	"WLANGast")		location="http://$IP:49000/upnp/control/wlanconfig3"
					uri="urn:dslforum-org:service:WLANConfiguration:3"
					SoapParam='NewEnable'
					if [ $2 = "0" ] || [ $2 = "1" ]; then
						Action='SetEnable'			
					    set_TR064 $2
					elif [ $2 = "state" ]; then 
						Action='GetInfo'
						get_TR064
					    set_CUxD_state $TR064_temp $3 $1
					elif [ $2 = "state1" ]; then 
						Action='GetInfo'
						get_TR064
					    set_CCU_SysVar $TR064_temp $3 $1
					fi
					;;

	"reboot") 		location="http://$IP:49000/upnp/control/deviceconfig"
					uri="urn:dslforum-org:service:DeviceConfig:1"
					Action='Reboot'
				SoapParam='NewX_AVM-DE_UrlSID'
;;
	"reconnect")	location="http://$IP:49000/upnp/control/deviceconfig"
					uri="urn:dslforum-org:service:DeviceConfig:1"
					Action='Reboot'
				SoapParam='NewX_AVM-DE_UrlSID'
									
					
;;
					
	"UMTS") 		LOGIN
					if [ $2 = "0" ] || [ $2 = "1" ]; then
						PerformPOST "umts:settings/enabled=$2&sid=$SID" "POST"
					elif [ $2 = "state" ]; then 
						get_UMTS_state
						set_CUxD_state "$stateUMTS" $1 $3 $stateUMTS
					fi
					;;

	"DECT")			LOGIN
					if [ $2 = "0" ] || [ $2 = "1" ]; then
						PerformPOST "dect:settings/enabled=$2&sid=$SID" "POST"
					elif [ $2 = "state" ]; then 
						get_DECT_state
						set_CUxD_state "$stateDECT" $1 $3 $stateDECT
					fi
					;;
	"WLANNacht")	LOGIN
					PerformPOST "wlan:settings/night_time_control_no_forced_off=$2&sid=$SID" "POST"
					;;
	"WLANAnwesend") get_network_user_devices
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/network_user_devices.lua?sid=$SID \n"
					anwesenheit=$(grep '_node = landevice' -A27 -B2 $network_user_devices | grep "wlan = 1" -B26 | grep "active = 1" -A24 | grep " name = " | sed -e 's/name =//' -e 's/,//')
					#anwesenheit=$(grep "wlan = 1" -B26 $network_user_devices | grep "active = 1" -A24 | grep " name = " | sed -e 's/name =//' -e 's/,//')
					echo "ausgabe: $anwesenheit"
					anwesenheit1=$(echo $anwesenheit | grep "$2" )
					if [ "$anwesenheit1" != "" ]; then
						Debugmsg=$Debugmsg"WLAN-Anwesend: $2 erkannt\n"
						set_CCU_SysVar $3 "1"
					else
						Debugmsg=$Debugmsg"WLAN-Anwesend: $2 nicht erkannt\n"
						set_CCU_SysVar $3 "0"
					fi
					Debugmsg=$Debugmsg"Alle WLAN-Geräte: $anwesenheit \n"
					;;
	"WLANOnline")	get_network_user_devices
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/network_user_devices.lua?sid=$SID \n"
					anwesenheit=$(grep '_node = landevice' -A27 -B2 $network_user_devices | grep "wlan = 1" -B26 | grep "online = 1" -B1 |grep name | sed -e 's/name =//' -e 's/,//')
					anwesenheit1=$(echo $anwesenheit | grep "$2" )
					if [ "$anwesenheit1" != "" ]; then
						Debugmsg=$Debugmsg"WLAN-Anwesend: $2 erkannt\n"
						set_CCU_SysVar $3 "1"
					else
						Debugmsg=$Debugmsg"WLAN-Anwesend: $2 nicht erkannt\n"
						set_CCU_SysVar $3 "0"
					fi
					Debugmsg=$Debugmsg"Alle WLAN-Geräte: $anwesenheit \n"
					;;
	"LANAnwesend") 	get_network_user_devices
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/network_user_devices.lua?sid=$SID \n"
					anwesenheit=$(grep '_node = landevice' -A27 -B2 $network_user_devices | grep "wlan = 0" -B26 | grep "active = 1" -A24 | grep " name = " | sed -e 's/name =//' -e 's/,//')
					anwesenheit1=$(echo $anwesenheit | grep "$2" )
					if [ "$anwesenheit1" != "" ]; then
						Debugmsg=$Debugmsg"LAN-Anwesend: $2 erkannt\n"
						set_CCU_SysVar $3 "1"
					else
						Debugmsg=$Debugmsg"LAN-Anwesend: $2 nicht erkannt\n"
						set_CCU_SysVar $3 "0"
					fi
					Debugmsg=$Debugmsg"Alle LAN-Geräte: $anwesenheit \n"
					;;
	"LANOnline") 	get_network_user_devices
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/network_user_devices.lua?sid=$SID \n"
					anwesenheit=$(grep '_node = landevice' -A27 -B2 $network_user_devices | grep "wlan = 0" -B26 | grep "online = 1" -B1 | grep name | sed -e 's/name =//' -e 's/,//')
					anwesenheit1=$(echo $anwesenheit | grep "$2" )
					if [ "$anwesenheit1" != "" ]; then
						Debugmsg=$Debugmsg"LAN-Anwesend: $2 erkannt\n"
						set_CCU_SysVar $3 "1"
					else
						Debugmsg=$Debugmsg"LAN-Anwesend: $2 nicht erkannt\n"
						set_CCU_SysVar $3 "0"
					fi
					echo $anwesenheit
					Debugmsg=$Debugmsg"Alle LAN-Geräte: $anwesenheit \n"
					;;
	"WakeOnLan")	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/network_user_devices.lua?sid=$SID \n"
					wol=$($WEBCLIENT "$FritzBoxURL/net/network_user_devices.lua?sid=$SID" | grep '"name"] = ' -B2 | grep $2 -B2 |grep mac | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' -e 's/mac =//' -e 's/,//' -e 's/^[ \t]*//;s/[ \t]*$//')
					Debugmsg=$Debugmsg"Debug:"$wol"\n"
					if [ "$wol" != "" ]; then
						Debugmsg=$Debugmsg"WOL-MAC: $2 erkannt: $wol\n"
						./ether-wake $wol
					else
						Debugmsg=$Debugmsg"WOL-MAC: $2 nicht erkannt\n"
					fi
					;;


	"Status-UMTS") 	LOGIN
					get_UMTS_state
					if [ $stateUMTS = "0" ] || [ $stateUMTS = "1" ] ; then
						Debugmsg=$Debugmsg"$1: $stateUMTS\n"
						set_CCU_SysVar $2 $stateUMTS
					else
						Debugmsg=$Debugmsg"$1: Fehler\n"
					fi
					;;
	"Status-DECT") 	LOGIN
					get_DECT_state
					if [ $stateDECT = "0" ] || [ $stateDECT = "1" ] ; then
						Debugmsg=$Debugmsg"$1: $stateDECT\n"
						set_CCU_SysVar $2 $stateDECT
					else
						Debugmsg=$Debugmsg"$1: Fehler\n"
					fi
					;;

	"Status-IP") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID" | grep 'connection0:status/ip')
					if echo $status | grep -q '"-"' ; then 
						Debugmsg=$Debugmsg"Status-IP: - \n"
						set_CCU_SysVar $2 "-"
					else
						ip=$(echo $status |  sed -e 's/= //;s/",//g;s/"*//g;s/\[connection0:status\/ip\]//g')
						Debugmsg=$Debugmsg"Status-IP: $ip \n"
						set_CCU_SysVar $2 $ip
					fi
					Debugmsg=$Debugmsg"Status-IP: $ip\n"
					;;										

	"Status-Verbindung") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID" | grep 'connection0:status/ip')
					if echo $status | grep -q '"-"' ; then 
						Debugmsg=$Debugmsg"Status-Verbindung: nicht verbunden\n"
						set_CCU_SysVar $2 "0"
					else
						Debugmsg=$Debugmsg"Status-Verbindung: verbunden\n"
						set_CCU_SysVar $2 "1"
					fi
					;;
	"Status-Verbindungszeit") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID" | grep "connection0:status/conntime_date" -A1)
					status2=$(echo -e $status | sed -e 's/"connection0:status\/conntime_date"//;s/"connection0:status\/conntime_time"//;s/\[\] =//g;s/"//g;s/,//g;s/\n//g;s/^ //g;s/ / /g;s/\./-/g;s/ /%20/g' | sed ':a;N;$!ba;s/\n//g')
					if echo $status2 | grep -q '\"-\"' ; then 
						Debugmsg=$Debugmsg"Status-Verbundindungszeit: - \n"
						set_CCU_SysVar $2 "-"
					else
						Debugmsg=$Debugmsg"Status-Verbundindungszeit: $status2 \n"
						set_CCU_SysVar $2 "$status2"
					fi
					Debugmsg=$Debugmsg"Status-Verbundindungszeit: $status2\n"					
					;;					

	"Status-WLANZeitschaltung") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/system/wlan_night.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/system/wlan_night.lua?sid=$SID" | grep 'name="active" id="uiActive"')
					if echo $status | grep -q 'id="uiActive" checked>' ; then
						Debugmsg=$Debugmsg"Status-WLANZeitschaltung: an\n"
						set_CCU_SysVar $2 "1"
					else
						Debugmsg=$Debugmsg"Status-WLANZeitschaltung: aus\n"
						set_CCU_SysVar $2 "0"
					fi
					;;


	*) 				Debugmsg=$Debugmsg"MAIN :  ERROR - Bitte wie folgt aufrufen: \n"
					Debugmsg=$Debugmsg"        ./FB-main.sh BEFEHL WERT (0=aus|1=ein) \n"
					Debugmsg=$Debugmsg"        Verfuegbar:  \n"
					Debugmsg=$Debugmsg"        ./FB-main.sh WLAN [0|1|state CUX2801xxx:x] \n"
					Debugmsg=$Debugmsg"        ./FB-main.sh WLAN5G [0|1|state CUX2801xxx:x] \n"
					Debugmsg=$Debugmsg"        ./FB-main.sh WLANGast [0|1|state CUX2801xxx:x] \n"
					Debugmsg=$Debugmsg"        -------------------------------------------------------------------------------------------------------------------------------------------------\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WLANNacht [0|1] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WLANAnwesend [Name des WLAN Geraetes] [Name der logischen Variable (Bool)in der CCU] - Beispiel: FritzBox.sh WLANAnwesend Geraet CCUVariable \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WLANOnline [Name des WLAN Geraetes] [Name der logischen Variable (Bool)in der CCU] - Beispiel: FritzBox.sh WLANOnline Geraet CCUVariable \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh LANAnwesend [Name des LAN Geraetes] [Name der logischen Variable (Bool)in der CCU] - Beispiel: FritzBox.sh LANAnwesend Geraet CCUVariable \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh LANOnline [Name des LAN Geraetes] [Name der logischen Variable (Bool)in der CCU] - Beispiel: FritzBox.sh LANOnline Geraet CCUVariable \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WakeOnLan [Name des LAN Geraetes] - Beispiel: FritzBox.sh WakeOnLan Geraetename \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh DECT [0|1|state  CUX2801xxx:x] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh UMTS [0|1|state  CUX2801xxx:x]] \n"


					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-DECT [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-DECT DECTanausVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-UMTS [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-UMTS UMTSanausVariableCCU \n"	

					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-IP [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh SStatus-IP ExterneIPVariableCCU \n"

					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-Verbindung [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-Verbindung InternetverbundenVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-Verbindungszeit [Name der logischen Variable (Zeichenkette)in der CCU] Beispiel: FritzBox.sh Status-Verbindungszeit InternetVerbindungszeitVariableCCU \n"

					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-WLANZeitschaltung  [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-WLANZeitschaltung WLANZeitschaltungVariableCCU \n"

					Debugmsg=$Debugmsg"        ./FritzBox.sh reboot \n"
					EndFritzBoxSkript 4 "Falscher-Parameter-Aufruf-$1-$2-$3-$4";;
esac
EndFritzBoxSkript 0 "Erfolgreich"
